#ifndef EFFSTRESS_H
#define EFFSTRESS_H

#include <stdio.h>
#include "alias.h"
struct matrix;
struct vectror;
struct XFILE;

/**
  This class defines artificial material model which combines
  a damage/(visco)plastictiy/elasticity models with the concept 
  of effective stresses. It can be used also for other types of
  'pore' pressures like a crystallisation pressure of water, slat, etc.
  
  Order of internal variables in the other array :
  -----------------------------------------------
  The model has no internal variables and the order of eqother array 
  is given by the used damage/plasticty models
  
  19.9.2012
*/
class effstress
{
 public:
  effstress (void);
  ~effstress (void);

  /// reading of parameters from file
  void read(XFILE *in); 

  /// computation of nonlinera stresses
  void nlstresses (long ipp, long im, long ido); 

  /// initializes mechmat::nonmechq array by constant value of pore pressure
  void initvalues(long ipp);

  /// marks required non-mechanical quantities
  void give_reqnmq(long *anmq);

  pore_press_comp ppct; /// type of pore pressure computation
  double ppv;           /// pore pressure value assumed for whole problem solved
};

#endif
