#include "elastortomat.h"
#include "global.h"
#include "intpoints.h"



elastortomat::elastortomat (void)
{
  allocm(6, 6, de);
}



elastortomat::~elastortomat (void)
{
}



void elastortomat::read (XFILE *in)
{
  xfscanf(in, "%k", "ortomat");
  readm(in, de);
}



void elastortomat::print (FILE *out)
{
  printm(de, out);
}



void elastortomat::matstiff (matrix &d,strastrestate ssst)
{
  switch (ssst)
  {
    case spacestress:{
      matstiff_spacestr (d);
      break;
    }
    default:
      print_err("unknown number of components of stress tensor is required", __FILE__, __LINE__, __func__);
  }
}



void elastortomat::matstiff_spacestr (matrix &d)
{
  copym(de, d);
}



void elastortomat::elmatstiff (matrix &d,strastrestate ssst)
{
  matstiff(d, ssst);
}



void elastortomat::nlstresses (long ipp)
{
  long i, n = Mm->ip[ipp].ncompstr;
  vector eps(n),sig(n);
  strastrestate ssst = Mm->ip[ipp].ssst;
  matrix d(n,n);
  
  //  initial values
  for (i=0;i<n;i++){
    eps[i]=Mm->ip[ipp].strain[i];
  }
  
  matstiff (d,ssst);
  mxv (d,eps,sig);

  for (i=0;i<n;i++){
    Mm->ip[ipp].stress[i]=sig[i];
  }
}
