#ifndef FIXORTODAM_H
#define FIXORTODAM_H

#include <stdio.h>
#include "gfunct.h"
#include "iotools.h"
#include "vector.h"

class matrix;

class fixortodam
{
 public:
  fixortodam (void);
  ~fixortodam (void);
  void read (XFILE *in);
  void initval(long ipp, long ido);
  void matstiff (matrix &d,long ipp,long ido);
  void tmatstiff (matrix &d,long ipp,long ido);
  void elmatstiff (matrix &d,long ipp);

  void glob_matcoord(long ipp, vector &epsg, vector &eps, matrix &epst);
  void matcoord_glob(long ipp, vector &sig, vector &sig_g);
  void locmat_glob_mstiff(long ipp, matrix &dl, matrix &dg);
  void compute_eqdispl(long ipp, matrix &epst, vector &xeq);
  void compute_dam (vector &xeq, vector &omegao, vector &omega);
  void secstiffmat(matrix &d, long ipp, vector &omega);

  void nlstresses (long ipp, long im, long ido);
  void updateval (long ipp,long im,long ido);


  /// tensile stregth in longitudinal direction
  double x1t;

  /// tensile stregth in the first transversal direction
  double x2t;

  /// tensile stregth in the second transversal direction
  double x3t;

  /** equivalent displacement in fully damaged state in longitudinal, the first transversal and the second 
      transversal directions (tension)*/
  vector xeqtf;

  /** equivalent displacement treshold in longitudinal, the first transversal and the second 
      transversal directions (tension)*/
  vector xeqt0;

  /// elements of the transformation matrix depending on the coordinates of the integration point
  gfunct t11;  
  gfunct t12;  
  gfunct t13;  
  gfunct t21;  
  gfunct t22;  
  gfunct t23;  
  gfunct t31;  
  gfunct t32;  
  gfunct t33;  
};

#endif
