#ifndef J2FLOW2_H
#define J2FLOW2_H

#include "iotools.h"
#include "strretalg.h"
struct matrix;
struct vector;
struct atsel;

/**
   class j2flow defines material model of plasticity based on J2 flow
   
   structure of stored data
   plastic strains, consistency parameter, hardening parametr
   
   JK
*/

class j2flow2
{
 public:
  j2flow2 (void);
  ~j2flow2 (void);
  void read (XFILE *in);
  void matstiff (matrix &d,long ipp,long ido);
  void tangentstiff (matrix &d, matrix &td, long ipp,long ido);
  double yieldfunction (matrix &sig,vector &q);
  void deryieldfsigma (matrix &sig,matrix &dfds);
  void deryielddsigmadsigma (matrix &sig,matrix &dfdsds);
  void deryieldfq (vector &dq);
  void deryieldfdqdq (matrix &dfdqdq);
  void deryieldfdsigmadq (matrix &dfdsdq);
  void plasmod (matrix &h);
  double plasmodscalar (vector &qtr);
  void updateq(double dgamma, vector &q);
  void nlstresses (long ipp, long im, long ido);
  void nonloc_nlstresses (long ipp, long im, long ido);
  void updateval (long ipp, long im, long ido);
  void giveirrstrains (long ipp, long ido, vector &epsp);
  void changeparam (atsel &atm,vector &val);
  double give_consparam (long ipp, long ido);
  long give_num_interparam ();
  void give_interparam (long ipp,long ido,vector &q);
  
  ///  flow stress
  double fs;
  ///  hardening parameter
  double k;
  ///  stress return algorithm
  strretalg sra;
};

#endif
