#ifndef LAYPLATE_H
#define LAYPLATE_H

#include "alias.h"
#include "iotools.h"
#include "strretalg.h"
#include "intpoints.h"
struct matrix;
struct vector;
struct atsel;

/**
   Class layplate defines layered model for plates.
   
   Josef Fiedler, 08/2014
*/

class layplate
{
 public:
  layplate (void);
  ~layplate (void);
  void read (XFILE *in);
  
  void   matstiff       (matrix &d, long ipp,long ido);
  void   nlstresses     (long ipp, long im, long ido);
  long   compeqother    (long ipp);
  long   compother      (long ipp);
  void   backup         (long ipp, double *&k, long j);
  void   restore_values (long ipp, double *k, long j);
  void   updateval      (long ipp, long im, long ido);


  /// number of layers
  long nl;
  /// number of materials on current layer
  long *nm;
  /// array of material types
  mattype **tm;
  /// array of number of appropriate material type
  long **idm;
  /// backup of informations stored on integration point
  intpoints bcup; 

};

#endif
