#ifndef LOADCASE_H
#define LOADCASE_H

#include "iotools.h"
#include "gfunct.h"
class loadn;
class loadel;
struct ivector;

/**
  Class loadcase defines load cases in static problems.
   
  Created by JK,
*/

class loadcase
{
 public:
  loadcase (void);
  ~loadcase (void);
  void read (XFILE *in);
  void print (FILE *out);
  void assemble (long lcid,double *rhs,double *flv, double scale);
  void compute_reactions (long lcid);
  void tempercontrib (long lcid,double *rhs,double scale);
  
  ///  number of loaded nodes
  long nln;
  ///  number of loaded elements
  long nle;
  ///  number of prescribed displacements
  long npd;
  ///  number of prescribed temperature changes
  long npt;
  
  ///  presence of temperature changes
  long tempchang;

  //  loaded nodes
  loadn *lon;
  //  loaded elements
  loadel *loe;
  //  prescribed displacements
  double *pd;
  //  prescribed temperature changes
  double *pt;
  // macro stresses in homogenization problems
  double *mstress;
  // macro strains in homogenization problems
  double *mstrain;
  //double *rhstemp;
  ///  data file for reading
  char *temp_file;
  /// number of multiple data files
  long ntemp_file;
  //  prescribed temperature changes as multiple values according to time
  double **pts;
  // time of individual temperature settings (file)
  double *temp_time;
};

#endif
