#ifndef STRRETALG_H
#define STRRETALG_H

#include "iotools.h"
#include "alias.h"



/**
  Class defines type of stress return algorithm.
  It contains all necessary informations about selected algorithm.
   
  Created by JK,
*/
class strretalg
{
 public:
  strretalg ();
  ~strretalg ();
  void read (XFILE *in);
  void print (FILE *out);
  stressretalgtype give_tsra ();
  long give_ni ();
  double give_err ();
  
  ///  type of stress return algorithm
  stressretalgtype tsra;
  ///  computer zero
  double zero;
  ///  maximum number of iterations
  long ni;
  ///  required accuracy
  double err;
};

#endif
