#ifndef VECTTENS_H
#define VECTTENS_H

#include "alias.h"

struct matrix;
struct vector;



/// converts %vector to second order tensor
void vector_tensor (vector &v,matrix &t,strastrestate ssst,strastre ss);
/// converts second order tensor to %vector
void tensor_vector (vector &v,matrix &t,strastrestate ssst,strastre ss);

/// creates auxiliary matrix (useful for thermal strains,...)
void tensor_vector_matrix (strastrestate ssst,matrix &m);

/// converts fourth order tensor to %matrix
void tensor4_matrix (matrix &m,matrix &t,strastrestate ssst);
/// converts fourth order tensor to %matrix
void gentensor_matrix (matrix &m,matrix &t,strastrestate ssst);

/// returns guess of stress/strain state depending on the number of components
strastrestate guess_ssst(long ncomp);

// converts long %vector to reduced %vector
//void longvect_shortvect (double *lv,double *sv,strastrestate ssst);

/// converts full-length stress/strain %vector to reduced %vector
void give_red_vector(vector &fv, vector &rv, strastrestate ssst);

/// converts reduced stress/strain %vector to full-length %vector
void give_full_vector(vector &fv, vector &rv, strastrestate ssst);

/// converts full-length stress/strain %vector to reduced %vector
void give_red_vector(double *fv, double *rv, strastrestate ssst);

/// converts reduced stress/strain %vector to full-length %vector
void give_full_vector(double *fv, double *rv, strastrestate ssst);
#endif
